/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 13/12/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import  java.util.Map;

import  org.springframework.data.domain.Page;
import  org.springframework.data.domain.Pageable;
import  org.springframework.data.jpa.repository.JpaRepository;
import  org.springframework.data.jpa.repository.Query;
import  org.springframework.data.repository.query.Param;
import  org.springframework.stereotype.Repository;

import com.portofolio.entity.Pekerjaan;
import com.portofolio.entity.vo.PekerjaanId;


@Repository("pekerjaanDao")
public interface PekerjaanDao extends JpaRepository<Pekerjaan, PekerjaanId> {

	@Query(QListAll)
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,@Param("statusEnabled") boolean statusEnabled, Pageable page);

	@Query(QListAll + " and model.namaPekerjaan like %:namaPekerjaan% ")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,@Param("namaPekerjaan") String namaPekerjaan, @Param("statusEnabled") boolean statusEnabled,Pageable page);

	@Query(QListAll + " and model.id.kdPekerjaan = :kdPekerjaan")
	Map<String, Object> findByKdPekerjaan(@Param("kdProfile") Integer kdProfile,@Param("kdPekerjaan") Integer kdPekerjaan, @Param("statusEnabled") boolean statusEnabled);

    
    String QListAll ="select new map(model.id.kdPekerjaan as kdPekerjaan,model.id.kdProfile as kdProfile "
            + ", model.namaPekerjaan as namaPekerjaan " 
            + ", model.reportDisplay as reportDisplay " 
            + ", model.kdPekerjaanHead as kdPekerjaanHead "
            + ", pekerjaanHead.namaPekerjaan as namaPekerjaanHead " 
            + ", model.kodeExternal as kodeExternal " 
            + ", model.namaExternal as namaExternal " 
            + ", model.statusEnabled as statusEnabled " 
            + ", model.noRec as noRec "
            + ", model.version as version )" 
            + " from Pekerjaan model left join model.id id "
            + " left join model.pekerjaanHead pekerjaanHead "
            + " left join model.profile profile where profile.kode =:kdProfile and model.statusEnabled = :statusEnabled "; 

}
